;
; UpdateCharacters
;

UpdateCharacters
    lda #0
    sta currentchar
-   jsr CopyCharacterToZeroPage
    lda flags
    and #FLAGS_ACTIVE
    beq +

UpdateCharacter
    ldx currentchar
    lda CharacterType,x
    asl
    tay
    lda JumpTable,y
    sta .updatecall+1
    lda JumpTable+1,y
    sta .updatecall+2
.updatecall
    jsr UpdateFloater    ; will be modified

    jsr CopyCharacterFromZeroPage
    lda #0
    sta CollidedBlockType
+   inc currentchar
    jsr CheckRasterLineLessThan
    lda currentchar
    cmp #CHAR_COUNT
    bne -
    rts

;
; CollideWithPlayer
;

CollideWithPlayer
    ldx #CHARINDEX_PLAYER
    jsr IsCollidingWithChar
    bcc +
    lda #1
    ldx #CHARINDEX_PLAYER
    jsr DamageChar
+   rts

;
; CollideWithPlayerBullet
;

CollideWithPlayerBullet
    ldx #CHARINDEX_BULLET
    jsr IsCollidingWithChar
    bcc +
    lda #5
    jsr DamageThisChar
        ; delete the bullet
    ldx #CHARINDEX_BULLET
    jsr ExplodeCharacter
+   rts

;
; CopyCharacter[To|From]ZeroPage
;
; copy the data for a character to/from the zero page
;

CopyCharacterToZeroPage
    ldx currentchar
    ldy CharacterLookup, x
    ldx #0
-   lda Characters, y
    sta xcoord, x
    iny
    inx
    cpx structsize
    bne -
    rts

CopyCharacterFromZeroPage
    ldx currentchar
    ldy CharacterLookup, x
    ldx #0
-   lda xcoord, x
    sta Characters, y
    iny
    inx
    cpx structsize
    bne -
    rts

DamageChar
; temps
    damageamount = ts
    
    sta damageamount
    ldy CharacterLookup,x
    lda Characters+OFFSET_HEALTH,y
    clc
    sbc damageamount
    sta Characters+OFFSET_HEALTH,y
    bpl +
    rts
+   lda #12     ; a quarter of a second
    sta Characters+OFFSET_DAMAGETIME,y
    lda Characters+OFFSET_FLAGS,y
    ora #FLAGS_DAMAGED
    sta Characters+OFFSET_FLAGS,y
    rts
    
DamageThisChar
    sta damageamount
    lda health
    clc
    sbc damageamount
    sta health
    bpl +
    rts
+   lda #12     ; a quarter of a second
    sta damagetime
    lda flags
    ora #FLAGS_DAMAGED
    sta flags
    rts

UpdateDamage
    lda health
    bpl +
    jsr ExplodeThisCharacter
    rts
+   ldx damagetime
    beq +
    dex
    stx damagetime
    bne +
    lda flags
    and #(!FLAGS_DAMAGED)
    sta flags
+   rts

;
; ExplodeThisCharacter
;

ExplodeThisCharacter
    ldx currentchar
    lda #CHARTYPE_EXPLOSION
    sta CharacterType,x
    lda #FLAGS_ACTIVE
    sta flags
    lda #0
    sta damagetime
    lda #(ExplosionSprites - Sprites)
    sta spriteoffset
    lda #8
    sta height
    ldx #172
    ldy #16
    jsr PlaySfx
    rts

;
; ExplodeCharacter
;
; IN:
; .X is the character to explode

ExplodeCharacter
    ldy CharacterLookup,x
    lda #(FLAGS_EXPLODE + FLAGS_ACTIVE)
    sta Characters + OFFSET_FLAGS,y
    rts

JumpTable
!word UpdateFloater
!word UpdateCrawler
!word UpdateFloater
!word UpdateCrawler
!word UpdateReactorPiece
!word UpdatePlayerBullet
!word UpdateExplosion
!word UpdatePlayer

