;
; UpdateExplosion
;
    
UpdateExplosion
    lda damagetime
    tay
    lsr
    tax
    lda TimesNine, x
    clc
    adc #(ExplosionSprites - Sprites)
    sta spriteoffset
    iny
    cpy #8
    bne +
    lda flags
    and #(!FLAGS_ACTIVE)
    sta flags
+   sty damagetime
    rts

;
; UpdateCrawler
;
; temps
    lionixscreenpos = ts

UpdateCrawler
            ; temporarily set direction
    lda xadd
    bne +
    lda #1
    sta xadd
+   jsr PreUpdateCreature
    lda updatecount
    and #3
    cmp #2
    bne +++
    lda flags
    and #FLAGS_XCOLLISION
    bne +
    lda xcoord
    and #3
    bne ++
    lda xcoord
    lsr
    lsr
    clc
    adc xadd
    sta lionixscreenpos
    lda ycoord
    asl
    adc #16
    adc lionixscreenpos
    tax
    lda screen,x
    cmp #FIRST_COLLIDABLE
    bpl ++
          ; swap direction
+   lda xadd
    eor #$ff
    tax
    inx
    stx xadd
++


    lda updatecount
    and #4
    lsr
    tax
    lda xadd
    bpl +
    inx
+   lda TimesNine, x
    ldx currentchar
    ldy CharacterType, x
    clc
    adc CharacterSpriteOffset, y
    sta spriteoffset

    jsr PostUpdateCreature
+++ rts
    
;
; [Pre|Post]UpdateCreature
;

PreUpdateCreature
    jsr CollideWithPlayer
    jsr CollideWithPlayerBullet
    jsr UpdateDamage
    rts

PostUpdateCreature
    jsr CollideX
    jsr CollideY
    rts


;
; UpdateReactorPiece
;

UpdateReactorPiece
    jsr PreUpdateCreature
    ldx currentchar
    lda CharacterType,x
    cmp #CHARTYPE_EXPLOSION
    bne +
    inc ReactorPiecesDestroyed
+   lda ReactorPiecesDestroyed
    cmp #4
    beq +
    ldx #(KillCpuString-StringBase)
    bpl ++
+   ldx #(PressSpaceString-StringBase)
++  jsr DrawString
    rts

;
; UpdateFloater
;

MoveTableX !byte -1,0,0,1
MoveTableY !byte 0,-2,2,0

UpdateFloater
    jsr PreUpdateCreature
    ldx currentchar
    ldy CharacterType, x
    lda CharacterSpriteOffset, y
    sta spriteoffset
    lda updatecount
    and #8
    beq +
    lda #9        ; height + color byte
    adc spriteoffset
    sta spriteoffset
+   lda updatecount
    and #1
    bne +++
    lda updatecount
    and #$f
    bne ++
    
!source "random.asm"    ; inline the function
    lsr                 ; drop the non-random bits
    lsr
    lsr
    lsr

    cmp #4
    bpl +
    tay
    lda MoveTableX,y
    sta xadd
    lda MoveTableY,y
    sta yadd
    jmp ++
            ; home on the player
+   cmp #9
    bmi +
    lda PlayerCharacter+OFFSET_XCOORD
    sec
    sbc xcoord
    jsr Sign
    sta xadd
    lda #0
    sta yadd
    beq ++
+   lda PlayerCharacter+OFFSET_YCOORD
    sec
    sbc ycoord
    jsr Sign
    asl
    sta yadd
    lda #0
    sta xadd
++  jsr PostUpdateCreature
+++ rts

Sign
    bpl +
    lda #-1
    rts
+   lda #1
    rts
