   MUSIC_ALT = 2
   MUSIC_CHAN1 = 0
   MUSIC_CHAN2 = 1
   
   MUSIC_VOLUME = 4
   SOUND_VOLUME = 15
   
; 3 C
; 6 F# G G# A A# A G#
; 3 D
; 6 G G# A A# B A# A

MusicTrack
!8 131, 16 + MUSIC_CHAN1
!8 211, 4 + MUSIC_CHAN2 + MUSIC_ALT
!8 1, 4 + MUSIC_CHAN2
!8 214, 4 + MUSIC_CHAN2
!8 1, 4 + MUSIC_CHAN2
!8 216, 4 + MUSIC_CHAN2
!8 1, 4 + MUSIC_CHAN2
!8 218, 4 + MUSIC_CHAN2 + MUSIC_ALT
!8 1, 4 + MUSIC_CHAN2
!8 220, 4 + MUSIC_CHAN2 + MUSIC_ALT
!8 1, 4 + MUSIC_CHAN2
!8 218, 4 + MUSIC_CHAN2 + MUSIC_ALT
!8 1, 4 + MUSIC_CHAN2
!8 216, 4 + MUSIC_CHAN2
!8 1, 80 + MUSIC_CHAN2
!8 145, 16 + MUSIC_CHAN1 + MUSIC_ALT
!8 214, 4 + MUSIC_CHAN2
!8 1, 4 + MUSIC_CHAN2
!8 216, 4 + MUSIC_CHAN2
!8 1, 4 + MUSIC_CHAN2
!8 218, 4 + MUSIC_CHAN2 + MUSIC_ALT
!8 1, 4 + MUSIC_CHAN2
!8 220, 4 + MUSIC_CHAN2 + MUSIC_ALT
!8 1, 4 + MUSIC_CHAN2
!8 222, 4 + MUSIC_CHAN2 + MUSIC_ALT
!8 1, 4 + MUSIC_CHAN2
!8 220, 4 + MUSIC_CHAN2 + MUSIC_ALT
!8 1, 4 + MUSIC_CHAN2
!8 218, 4 + MUSIC_CHAN2 + MUSIC_ALT
!8 1, 80 + MUSIC_CHAN2
!8 0

;
; StartMusic
;
; IN:
; .X is musicptr lobyte
; .Y is musicptr hibyte
;

StartMusic ; 33 bytes
    lda #$00
    sta $900b ; stop playing on channel 0
    sta $900c ; stop playing on channel 1
    sta MusicIndex
    sta MusicToggleNote
    stx MusicPtr
    sty MusicPtr+1
    ldy #1
    lda (MusicPtr),y
    and #$fc     ; extract the length
    sta MusicDelay
    rts

;
; UpdateMusic
;
; temps
    musicnote = ts
    musicdata = ts+1

UpdateMusic ; 75 bytes
    lda #(AUXCOLOR_ORANGE + MUSIC_VOLUME) ; set the volume
    sta $900e
    lda #$02
    eor MusicToggleNote
    sta MusicToggleNote
    lda MusicIndex
    asl
    tay
    lda (MusicPtr), y
    sta musicnote
    iny
    lda (MusicPtr), y
    sta musicdata
    and #$02
    and MusicToggleNote
    beq +
    inc musicnote
+   lda musicdata
    and #$01
    tax
    lda musicnote
    sta $900b, x ; channel 1
++  dec MusicDelay
    beq +
    rts
+   inc MusicIndex
    iny
    lda (MusicPtr), y
    bne +
    ldx MusicPtr
    ldy MusicPtr+1
    jsr StartMusic
    rts
+   iny
    lda (MusicPtr), y
    and #$fc
    sta MusicDelay
    rts

;
; PlaySfx
;
; IN:
; .X is frequency
; .Y is time
;

PlaySfx
    stx $900d
    sty SfxDuration
    rts

UpdateSfx
    ldx SfxDuration
    bne +
    rts
+   dex
    stx SfxDuration
    bne +
    stx $900d
    lda #(AUXCOLOR_ORANGE + SOUND_VOLUME)
    sta $900e
+   rts

