spritedefs = $300 - 25*8
OldCharPositions = spritedefs - 25
CharPositions = OldCharPositions - 25

;
; // Render
; StartRenderSprites
; RenderSprite RenderSprite ...
; // Update
; EraseAndCopyUpSprites
;

;
; StartRenderSprites
;

CurrentChar !byte 01

ResetSprites
    ldx #24
    lda #0
-   sta CharPositions, x
    sta OldCharPositions, x
    dex
    bpl -
    ldx #(25*8)
-   sta spritedefs-1,x
    sta chardefs-1,x
    dex
    bne -
    lda #1
    sta CurrentChar
    rts

StartRenderSprites
    lda #0
        ; unrolling this loop saves 720 render cycles
    ldy #$37 ; need to overlap a bit to clear characters 0-24
-   sta spritedefs,y
    sta spritedefs+$30,y
    sta spritedefs+$60,y
    sta spritedefs+$90,y
    dey
    bpl -
        ; copy CharPositions to OldCharPositions
    ldx #24
-   lda CharPositions, x
    sta OldCharPositions, x
    lda #0
    sta CharPositions, x
    dex
    bpl -
    lda #1
    sta CurrentChar
    rts

EraseAndCopyUpSprites
        ; clear screen[CharPositions[1..24]]
    ldy #24
-   ldx OldCharPositions, y
    beq +
    lda screen, x
    cmp #FIRST_COLLIDABLE
    bpl +
    lda #0
    sta screen, x
+   dey
    bne -
    
    
    ; will need to do the ORing of the sprites here!
    ; then modify render sprite line to match

CopyUpSprites
    ldx #(25*8)
-   lda spritedefs-1,x
    sta chardefs-1,x
    dex
    bne -
    
    jmp +++
--
        ; write chars used to the screen
    ldy CurrentChar
    ldx CharPositions, y
    beq +++
    lda screen, x
    cmp #FIRST_COLLIDABLE     ; do not overwrite the other tiles (for explosions)
    bpl +++
    lda ColorsUsed, y
    sta screencols, x
    lda screen, x
    bne ++
    txa
    lda CurrentChar
    sta screen, x
    jmp +++
++      ; or with current char
    asl
    asl
    asl
    tax
    lda CurrentChar
    asl
    asl
    asl
    tay
-   lda chardefs, x
    ora chardefs, y
    sta chardefs, x
    inx
    iny
    tya
    and #7
    bne -
    
+++
    dec CurrentChar
    bne --
    rts



;
; RenderSprite
;
; temps
    temp = ts
    screenpos = ts+1
    hremaining = ts+2
    currentspriteline = ts+3
    currenty = ts+4
    xpart = ts+5     ; (xcoord&3)<<1
    spriteshiftedsection = ts+6
    spritecolor = ts+7
    currentspritelinedata = ts+8
    renderdamaged = ts+9
    
RenderSprite
    ldx spriteoffset
    lda Sprites, x
    sta spritecolor
    inx
    stx currentspriteline
    lda flags
    and #FLAGS_DAMAGED
    sta renderdamaged

    lda xcoord
    and #3
    asl
    sta xpart
    lda #6
    sec
    sbc xpart
    sta .skiplsr + 1    ; bcc 6-2*(xcoord&3)
    lda xpart
    sbc #2
    sta .skipasl + 1    ; bcc 2*(xcoord&3)-2

    lda height
    sta hremaining
    lda ycoord
    sta currenty
    lda xcoord
    lsr
    lsr
    sta temp
    lda currenty
    and #$f8
    asl
    clc
    adc temp
    sta screenpos
-   
    ldy currentspriteline
    lda Sprites,y
    ldx renderdamaged
    beq +
    lsr
    ora Sprites,y
    and #$55
+   sta currentspritelinedata

    clc
.skiplsr
    bcc +     ; will be modified to shift sprite
    lsr
    lsr
    lsr
    lsr
    lsr
    lsr
+   sta spriteshiftedsection
    
    lda screenpos
    ldx CurrentChar
    jsr RenderSpriteLineSection
    
    lda xcoord
    and #3
    beq ++

    lda currentspritelinedata
    clc
.skipasl
    bcc +        ; will be modified to shift sprite
    asl
    asl
    asl
    asl
    asl
    asl
+   sta spriteshiftedsection

    lda screenpos
    clc
    adc #1
    ldx CurrentChar
    inx
    jsr RenderSpriteLineSection

++  inc currentspriteline
    inc currenty
    lda currenty
    and #7
    bne +
    lda screenpos
    clc
    adc #16
    sta screenpos
    inc CurrentChar
    inc CurrentChar
+   dec hremaining
    bne -
    inc CurrentChar
    inc CurrentChar
    rts

RenderSpriteLineSection
    sta CharPositions, x
    lda spritecolor
    sta ColorsUsed, x
    txa
    asl
    asl
    asl
    sta temp
    lda currenty
    and #7
    clc
    adc temp
    tay
    lda spriteshiftedsection
    sta spritedefs, y
    rts
