;
; DrawString
;
; IN:
; .X is string offset from StringBase
;
; temps
    textcolor = ts

DrawString
    ldy StringBase, x
    inx
    lda StringBase, x
    sta textcolor
    jmp +
-   sta lowerscreen, y
    lda textcolor
    sta lowerscreencols, y
    iny
+   inx
    lda StringBase, x
    bne -
    rts

;
; WaitForRasterLine
;

WaitForRasterLine
-   lda $9004
    and #$fe
    cmp rasterline
    bne -
    nop     ; delay for NTSC
    nop
    lda #$f0
    sta $9005   ; change char defs for text portion of screen
    rts

;
; WaitForRasterLineLessThan
;

WaitForRasterLineLessThan
-   lda $9004
    and #$fe
    cmp rasterline
    bpl -
    lda #$ff
    sta $9005   ; set char defs for render section of screen
    rts

;
; CheckRasterLineLessThan
;

CheckRasterLineLessThan
    lda $9004
    and #$fe
    cmp rasterline
    bpl +
    lda #$ff
    sta $9005   ; set char defs for render section of screen
+   rts

;
; ClearScreen
;

ClearScreen
        ; fill screen with empty, colors with $dd
        ; unrolled so I can use bpl on the loop check
    ldy #$7f
-   lda #0
    sta screen,y
    sta screen+$80,y
    lda #32
    sta screen+$100,y
    lda #$0d
    sta screencols,y
    sta screencols+$80,y
    lda #$0    ; black
    sta screencols+$100,y
    dey
    bpl -
    rts
    
;
; CheckSpace
;

CheckSpace
    ldx #$ef        ; look for SPACE pressed
    ldy #$01
    jsr ScanKeyRow
    cpx #$01
    rts

; the table continues backwards
!byte -9
CharacterLookup
TimesNine
!byte 0,9,18,27,36,45,54

;
; SplitIntoNibbles
;

SplitIntoNibbles
    pha
    and #$0f
    sta lownibble
    pla
    lsr
    lsr
    lsr
    lsr
    sta highnibble
    rts
